#ifndef DGX_LEVEL_3D_H
#define DGX_LEVEL_3D_H

#include <engine/3d/render.h>
#include <engine/asset.h>

#define NUM_TRIGT		32
#define MAX_LVLPARTS		16
#define MAX_UNIQUE_POLY_LP	(MAX_UNIQUE_POLY/2)

#define LP_F			(1<<0)
#define LP_FT			(1<<1)
#define LP_G			(1<<2)
#define LP_GT			(1<<3)

struct Level3D
{
	/*
	 *                     lptype[X]
	 *                        |
	 *                        |
	 *                        v
	 * lp[MAX_LVLPARTS][F, FT, G, GT][LOD_HI, LOD_LO]
	 */

	struct AssetMTD		lp[MAX_LVLPARTS][MAX_UNIQUE_POLY_LP][NUM_LOD];
	unsigned short		version, lptotal;
	unsigned int		lptype[MAX_LVLPARTS]; /* bitmask */
	unsigned int		lptimidx[MAX_LVLPARTS]; /* for TEX file */
	int			*lpdiv[MAX_LVLPARTS]; /* to be set manually by the programmer */

	CVECTOR			sky;

	struct AssetCXC		cxc;
	struct AssetCXC		lplod;

	int			idx;

	/* bitmasks */
	int			areatrigm;
	int			lplodm;

	enum
	{
		TRIGT_LEVEL_NOTHING,
		TRIGT_LEVEL_END,
		TRIGT_PWRUP_SPDUP,
		TRIGT_PWRUP_TIMEFREEZE,
		TRIGT_PWRUP_COIN
	}areatrigt[NUM_TRIGT];
}extern level;

#endif

